#include "StdAfx.h"
#include "UISysMsgElement.h"

//sys item
#define DEF_SYS_MSG_POS_TOP_REL_Y			(16)
#define DEF_SYS_MSG_POS_LEFT_REL_X			(13)
#define DEF_SYS_MSG_POS_BOTTOM_REL_Y		(5)
#define DEF_SYS_MSG_POS_TOP_INNER_Y			(0)
#define DEF_SYS_MSG_POS_BOTTOM_INNER_Y		(0)
#define DEF_SYS_MSG_POS_INNER_X				(8)
#define DEF_SYS_MSG_ARROW_REL_Y             (5)


#define DEF_SYS_MSG_LEFT_REL_X  (25)
#define DEF_SYS_MSG_RIGHT_REL_X (15)

UISysMsgElement::UISysMsgElement( CChatItem* pChatItem, IUIElementResouce* pResouce) : UIElement(pChatItem, pResouce)
{
	m_rcMsg.SetRectEmpty();
	m_rcSysArrow.SetRectEmpty();
}

UISysMsgElement::~UISysMsgElement( void )
{

}

BOOL UISysMsgElement::Draw( Graphics *graph )
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	CRect rcClient;
	m_pResouce->GetCurrentWnd()->GetClientRect(&rcClient);
	ImageAttributes ImgAttr;
	if (m_dwFlags & DEF_CHAT_MSG_DATE && (CHAT_BUBBLE == m_pResouce->GetChatDisplayType()))
	{
		//DrawDate(graph);
	}
	
	if (m_pResouce)
	{
		Image* imageSysArrow = m_pResouce->GetSysMsgArrowImage();
		if (imageSysArrow)
		{
			CRect rcSysArrow = m_rcSysArrow;
			rcSysArrow.OffsetRect(ptOffset);
			//rcSysArrow.OffsetRect(ptPos);
			DrawImageToDest(graph, imageSysArrow, &rcClient, &rcSysArrow, &ImgAttr);
		}
		CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);

		CRect rcMsg = m_rcMsg;
		rcMsg.OffsetRect(ptOffset);
		Color clText = CColorConvert::HEX2Color(0x7284a0);
		LPTextRange pRange = pMsgItem->GetSelectRange();
		REAL fontHeight = 9;
		DrawChatText(graph, pMsgItem->GetMsg(), &rcClient, &rcMsg, pMsgItem->GetFontFaceName(), fontHeight/*pMsgItem->GetFontHeight()*/,
			StringAlignmentNear, FontStyleRegular, clText, pRange->IsValid(), pRange->nStart, pRange->nEnd);
		//CRect rcItem = m_rcItem;
		//rcItem.OffsetRect(ptOffset);
		//Pen pen(Color(255, 255, 0, 0));
		//graph->DrawRectangle(&pen, rcItem.left, rcItem.top, rcItem.Width(), rcItem.Height());
		return TRUE;
	}
	return FALSE;
}

CSize UISysMsgElement::CalcSize( const CPoint& ptPos, DWORD dwFlags )
{
	CSize sz(0, 0);
	CPoint ptOffset = ptPos;
	if (dwFlags & DEF_CHAT_MSG_DATE && (CHAT_BUBBLE == m_pResouce->GetChatDisplayType()))
	{
		//CalcDateSize(ptOffset, sz);
		//ptOffset.y += sz.cy;
	}
	CRect rcClient  = m_pResouce->GetViewRect();;

	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);

	int nLeft = DEF_SYS_MSG_POS_LEFT_REL_X;
	int nTop  = DEF_SYS_MSG_POS_TOP_REL_Y;
	sz.cy += DEF_SYS_MSG_POS_TOP_REL_Y;

	m_rcSysArrow.left = nLeft;
	m_rcSysArrow.top = nTop;

	Image* imageSysArrow = m_pResouce->GetSysMsgArrowImage();
	if (imageSysArrow)
	{
		m_rcSysArrow.top += DEF_SYS_MSG_ARROW_REL_Y;
		m_rcSysArrow.bottom = m_rcSysArrow.top + imageSysArrow->GetHeight();
		m_rcSysArrow.right = m_rcSysArrow.left + imageSysArrow->GetWidth();

		m_rcSysArrow.OffsetRect(ptOffset);
		nLeft += imageSysArrow->GetWidth();
		nLeft += DEF_SYS_MSG_POS_INNER_X;
	}

	CSize szMsg(0, 0);
	CRect rtMsg(nLeft, 0, rcClient.Width() - (DEF_SYS_MSG_LEFT_REL_X + DEF_SYS_MSG_RIGHT_REL_X), 500);
	RecalcTextRectVert(m_pResouce->GetCurrentWnd(), pMsgItem->GetMsg(), 
		pMsgItem->GetFontFaceName(), pMsgItem->GetFontHeight(), FontStyleRegular, rtMsg, szMsg);

	m_rcMsg.left = nLeft;
	m_rcMsg.top  = nTop;

	m_rcMsg.bottom = m_rcMsg.top + szMsg.cy;
	m_rcMsg.right  = m_rcMsg.left + szMsg.cx;

	m_rcMsg.OffsetRect(ptOffset);

	sz.cy += szMsg.cy;
	sz.cx = max(szMsg.cx, sz.cx);

	m_rcItem.SetRect(DEF_ITEM_POS_LEFT_REL_X, 0, m_pResouce->GetViewRect().Width() - DEF_ITEM_POS_RIGHT_REL_X, sz.cy);
	m_rcItem.OffsetRect(ptOffset);
	m_dwFlags = dwFlags;
	return sz;
}

void UISysMsgElement::OnLButtonDown( UINT nFlags, CPoint point )
{
	ResetSelectRange();
	//m_pResouce->InvalidateElement(this, FALSE);
	UIElement::OnLButtonDown(nFlags, point);
}

void UISysMsgElement::OnLButtonDblClk( UINT nFlags, CPoint point )
{
	_SetChatSelectedItem(point, point, TRUE);
	//m_pResouce->InvalidateElement(this, FALSE);
}

BOOL UISysMsgElement::OnMouseMove( UINT nFlags, CPoint point )
{
	BOOL bHandled = FALSE;
	int nCursor = CURSOR_DEFAULT;
	if (!(MK_LBUTTON & nFlags))
	{
		if (m_rcMsg.PtInRect(point))
		{
			bHandled = TRUE;
			nCursor = CURSOR_IBEAM;
		}
	}
	 
	if (MK_LBUTTON & nFlags && m_pResouce->IsMouseSelection())
	{

		CPoint ptStart = m_pResouce->GetSelectionStartPoint();
		CPoint ptEnd = point;


		PlainNormalizePoint(ptStart, ptEnd);
		_SetChatSelectedItem(ptStart, ptEnd, FALSE);
		//m_pResouce->InvalidateElement(this, FALSE);

	}
	return bHandled;
}

void UISysMsgElement::_SetChatSelectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord)
{
	CString strMsg = m_pChatItem->GetChatItemInfo()->strMsg;
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
	ASSERT(pMsgItem);

	if (pMsgItem)
	{
		LPTextRange pTextRange = pMsgItem->GetSelectRange();

		pTextRange->Reset();
		int nSelStart = -1;
		int nSelEnd = -1;
		int nTop = m_rcMsg.top;
		int nBottom = m_rcMsg.bottom;

		int nMsgLength = strMsg.GetLength();

		if (ptStart.y < nTop)
		{
			if (ptEnd.y <= nTop)
			{
				//Select None, do nothing
			}
			else if(ptEnd.y > nBottom)
			{
				//Select All
				nSelStart = 0;
				nSelEnd = nMsgLength - 1;
			}
			else
			{
				//Select Part
				nSelStart = 0;
				nSelEnd = _GetStringIndexUnderPoint(ptEnd);
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}
		}
		else if(ptStart.y < nBottom)
		{
			nSelStart = _GetStringIndexUnderPoint(ptStart);
			if (-1 == nSelStart)
			{
				nSelStart = 0;
			}
			if (ptEnd.y < nBottom)
			{
				nSelEnd = _GetStringIndexUnderPoint(ptEnd);
				if (-1 == nSelEnd)
				{
					nSelEnd = nMsgLength - 1;
				}
			}
			else
			{
				//Select All
				nSelEnd = nMsgLength - 1;
			}
		}
		else
		{
			//Select None, do thing
		}

		if (nSelStart > 0 && bSelectWord)
		{
			CString leftString = strMsg.Mid(0, nSelStart);

			int nIndex = leftString.ReverseFind(' ');
			if (-1 >= nIndex)
			{
				nSelStart = 0;
			}
			else
			{
				nSelStart = nIndex + 1;
			}

			nSelEnd = strMsg.Find(' ', nSelStart);
			if (-1 == nSelEnd)
			{
				nSelEnd = nMsgLength - 1;
			}
		}
		pTextRange->nStart = nSelStart;
		pTextRange->nEnd = nSelEnd;

		pTextRange->Normalize();
	}
}

int UISysMsgElement::_GetStringIndexUnderPoint( CPoint point )
{
	//CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);

	CString strMsg = m_pChatItem->GetChatItemInfo()->strMsg;

	if (strMsg.IsEmpty())
		return -1;

	CDC *pDC = m_pResouce->GetCurrentWnd()->GetDC();

	if (!pDC)
		return -1;

	Graphics graph(pDC->m_hDC);

	Gdiplus::Font myFont(m_pChatItem->GetFontFaceName(), m_pChatItem->GetFontHeight(), m_pChatItem->GetFontStyle());
	StringFormat format;
	format.SetAlignment(StringAlignmentNear);

	RectF layoutRect((Gdiplus::REAL)m_rcMsg.left, (Gdiplus::REAL)m_rcMsg.top,
		(Gdiplus::REAL)m_rcMsg.Width(), (Gdiplus::REAL)m_rcMsg.Height());

	CharacterRange range = CharacterRange(0, strMsg.GetLength());
	format.SetMeasurableCharacterRanges(1, &range);

	Region selectedRgn;
	graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);

	if (!selectedRgn.IsVisible(point.x, point.y, &graph))
	{
		m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
		return -1;
	}

	int nMin = 0;
	int nMax = strMsg.GetLength();
	int nMid = 0;

	while (nMin < nMax)
	{
		nMid = (nMin + nMax) / 2;

		if (nMid == nMin || nMid == nMax)
			break;

		range = CharacterRange(nMin, nMid - nMin);
		format.SetMeasurableCharacterRanges(1, &range);

		graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), &myFont, layoutRect, &format, 1, &selectedRgn);

		if (selectedRgn.IsVisible(point.x, point.y, &graph))
		{
			nMax = nMid;
		}
		else
		{
			nMin = nMid;
		}
	}

	m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
	return nMid;
}
